      implicit none
      real*8 x,y,z,h,hmax,hmin
      real*8 a,yinitial,f,g,n,ynew
      real*8 dh(6),xarg,yarg,zarg
      real*8 k1,k2,k3,k4,k5,k6
      real*8 l1,l2,l3,l4,l5,l6
      real*8 tol,Ry,Rz,deltay,deltaz,R
      real*8 x2,x3,x4,x5,x6,delta,amin,scaledr
      character LINE1*40, LINE2*40, LINE3*40
      real*4 xiplot(1000),thplot(1000),thplotn(1000)
      real*4 xmin,xmax,ymin,ymax,narray(7)
      common n
      integer icount,iout,index,i,npts,loop
      integer cindex,ii

      dh(1)=0.
      dh(2)=1./4.
      dh(3)=3./8.
      dh(4)=12./13.
      dh(5)=1.
      dh(6)=1./2.
      narray(1)=0
      narray(2)=0.5
      narray(3)=1
      narray(4)=1.5
      narray(5)=2
      narray(6)=3
      narray(7)=4
      cindex=1


C	This Program solves the Lane-Emden Equation'
C	It uses the Runge-Kutta-Fehlberg method with a 
C	tolerance of 1.e-8 (or user specififed!)


C     Place restrictions on hmax and hmin
C     These are also used to find the edge accurately
      write(6,*) '      '
C      write(6,*) ' Enter maximum step-length h (larger for larger n)'
C      read(5,*) hmax
      hmax=0.2

C      write(6,*) ' Enter tolerance = maximum error'
C      read(5,*) tol
      tol=1.e-5
      hmin=tol
      write(6,444) hmax, tol
 444  format(' Using hmax=', f5.3,' and tolerance=',1pe10.3)

      do loop=1,7
         n=narray(loop)
         index=0
C      write(6,*) ' Enter polytropic index n'
C      read(5,*) n

C      write(6,*) '      '
C      write(6,*) ' Output every iout steps: Enter iout (99 for none)'
C      read(5,*) iout
      iout=99
C      tol=1.d-8

C     Start at x=tolerance
      x=tol

C     Use series solution to begin near origin
      x2=x*x
      x3=x2*x
      x4=x2*x2
      x5=x4*x
      x6=x4*x2
      y=1-x2/6. + n*x4/120.-n*(8*n-5)*x6/(42*360)
      z=-x/3. +n*x3/30.-n*(8*n-5)*x5/(7*360)

C     Start with h=hmin=tol
      h=x

      if(iout.ne.99) print 11
 11   format('          x            y         z        h')
      if(iout.ne.99) print 10,x,y,z,h

      icount=0

 100  continue
C     We should never use the next line !
      if(y.le.0) go to 200

      k1=h*f(x,y,z)
      l1=h*g(x,y,z)

      xarg=x+dh(2)*h
      yarg=y+k1*0.25
      if(yarg.le.0) go to 200
C     Then non-integer n will cause problems. 
C     Reduce h and restart this step.
      zarg=z+l1*0.25
      k2=h*f(xarg,yarg,zarg)
      l2=h*g(xarg,yarg,zarg)

      xarg=x+dh(3)*h
      yarg=y+3.*(k1+3.*k2)/32.
      if(yarg.le.0) go to 200
      zarg=z+3.*(l1+3.*l2)/32.
      k3=h*f(xarg,yarg,zarg)
      l3=h*g(xarg,yarg,zarg)

      xarg=x+dh(4)*h
      yarg=y+(1932.*k1-7200.*k2+7296.*k3)/2197.
      if(yarg.le.0) go to 200
      zarg=z+(1932.*l1-7200.*l2+7296.*l3)/2197.
      k4=h*f(xarg,yarg,zarg)
      l4=h*g(xarg,yarg,zarg)

      xarg=x+dh(5)*h
      yarg=y+439.*k1/216.-8.*k2+3680.*k3/513.-845.*k4/4104.
      if(yarg.le.0) go to 200
      zarg=z+439.*l1/216.-8.*l2+3680.*l3/513.-845.*l4/4104.
      k5=h*f(xarg,yarg,zarg)
      l5=h*g(xarg,yarg,zarg)

      xarg=x+0.5*h
      yarg=y-8.*k1/27.+2.*k2-3544.*k3/2565.+ 
     &    1859.*k4/4104.-11.*k5/40.
	if(yarg.le.0) go to 200
      zarg=z-8.*l1/27.+2.*l2-3544.*l3/2565.+ 
     &    1859.*l4/4104.-11.*l5/40.
      k6=h*f(xarg,yarg,zarg)
      l6=h*g(xarg,yarg,zarg)

C     Error controlling R values
      Ry=abs(k1/360.-128.*k3/4275.-2197.*k4/75240.+
     &     k5/50.+2.*k6/55.)/h
      Rz=abs(l1/360.-128.*l3/4275.-2197.*l4/75240.+
     &     l5/50.+2.*l6/55.)/h
      R=min(Ry,Rz)
      if(R.ne.0) delta=0.84*(tol/R)**0.25

C     if R < tol then this step is accepted.....
      if(R.le.tol) then
         ynew=y+25.*k1/216.+1408.*k3/2565.+2197.*k4/4104.-0.2*k5
C........provided y is still positive.......
C        if this y < 0 then reduce h and re-compute this step...
         if(ynew.lt.0) then
            if(h.gt.tol) then
               h=0.5*h
               go to 100
            else
C..............unless h < tol = hmin. In this case
C              we have found the surface...so print and stop.
300	       print 30,x,-x/(3*z),-x*x*z
               stop
            endif
         endif

C        Step accepted, y > 0

C        Update x and z also
         y=ynew
         x=x+h
         z=z+25.*l1/216.+1408.*l3/2565.+2197.*l4/4104.
     &        -0.2*l5



C        Set up stuff to plot
         index=index+1
         xiplot(index)=x
         thplot(index)=y
         thplotn(index)=log10(y**n)

C        If required, print out the x,y,z and h for this step
	 icount=icount+1
         if(iout.ne.99) then
            if(mod(icount,iout).eq.0) print 10,x,y,z,h
         endif
      else
C        Here R > tol, so we must reduce h.
C        This step is NOT accepted.
	 if(iout.ne.99) print 20,Ry,Rz,tol,h
      endif

C     Now adjust h
      if(delta.le.0.5) then
         h=0.5*h
      else if (delta.gt.2) then
         h=2.*h
      else
         h=delta*h
      endif

      if(h.gt.hmax) h = hmax
      if(y.lt.0) stop
      if(h.lt.hmin) h=hmin
      go to 100

200   continue
C     Must reduce h as y went negative on this step
      h=0.5*h
C     But if this makes h < tol, then we have finished !
      if(h.lt.tol) then
	     print 30,n,x,-x/(3*z),-x*x*z
             scaledr=x
             go to 500
      endif
C     Reduced h....go back to calculate the next step.
      go to 100

C     FORMAT statements
10    format(2x,1pe14.6,2x,0pf8.6,2x,f8.5,2x,f8.5)
20    format('   *Ry=',e11.4,' Rz=',e11.4,' tol=',e10.3,
     &       '   h=',f6.4)
30    format(//,'For n=',f3.1,' : radius            = ',f10.5,/,
     &	        '            rho(c)/rho(bar)   = ',f10.5,/,
     &          '            -x^2 d(theta)/dx  = ',f10.5,//)


 500  continue
C     Plot stuff
      npts=index

      if(loop.eq.1) then
         xmin=0
         xmax=1
         ymin=-3
         ymax=0.1
         CALL PGBEG(0,'?',1,1)
         call pgpap(10.0,0.8)
         call pgenv(xmin,xmax,ymin,ymax,0,0)
         call pglabel('Xi/Xi_1','log10(Theta**n = rho/rho_c)',
     &                'Polytrope Solutions for various n')
C         write(LINE1,510)
C         write(LINE2,520)
C         write(LINE3,530)
C         call pgmtxt('T',-1.5,0.5,0.5,LINE1)
C         call pgmtxt('T',-3.0,0.5,0.5,LINE2)
C         call pgmtxt('T',-4.5,0.5,0.5,LINE3)
C 510     format('n=0 (dark green)  n=0.5 (blue)  n=1 (cyan)')
C 520     format('n=1.5 (magenta)  n=2 (yellow)')
C 530     format('n=3 (orange)  n=4 (light green)')

         write(LINE1,510)
         call pgsci(2)
         call pgmtxt('T',-2.0,0.9,0.5,LINE1)

         write(LINE1,520)
         call pgsci(3)
         call pgmtxt('T',-3.8,0.85,0.5,LINE1)

         write(LINE1,530)
         call pgsci(4)
         call pgmtxt('T',-6.0,0.8,0.5,LINE1)

         write(LINE1,540)
         call pgsci(5)
         call pgmtxt('T',-7.0,0.68,0.5,LINE1)

         write(LINE1,550)
         call pgsci(6)
         call pgmtxt('T',-10.,0.62,0.5,LINE1)

         write(LINE1,560)
         call pgsci(7)
         call pgmtxt('T',-15.0,0.5,0.5,LINE1)

         write(LINE1,570)
         call pgsci(8)
         call pgmtxt('T',-18.0,0.28,0.5,LINE1)



 510     format('n=0.0')
 520     format('n=0.5')
 530     format('n=1.0')
 540     format('n=1.5')
 550     format('n=2.0')
 560     format('n=3.0')
 570     format('n=4.0')


C  n=0.5 (blue)  n=1 (cyan)')
C 520     format('n=1.5 (magenta)  n=2 (yellow)')
C 530     format('n=3 (orange)  n=4 (light green)')
      endif



      do ii=1,npts
         xiplot(ii)=xiplot(ii)/scaledr
      enddo

      cindex=cindex+1
      call pgsci(cindex)
      call pgline(npts,xiplot,thplotn)
      call pgpoint(npts,xiplot,thplotn,2)

      enddo


      call pgend

      stop
      end




C     f is z=f(x,y,z)=dy/dz
      real*8 function f(x,y,z)
      real*8 x,y,z
      f=z
      return
      end

C     g is z'=g(x,y,z)=dz/dz
      real*8 function g(x,y,z)
      common n
      real*8 x,y,z,n
      g=-2*z/x -y**n
      return
      end
