      implicit none
      character LINE1*40
      real*4 L(10),R(10),Te(10),lsun,rsun
      real*4 pi,sigma,xmin,xmax,ymin,ymax
      real*4 rL(10),rTe(10),x(2),y(2)
      integer i,j


	pi=3.14159
	sigma=5.67e-5
	Rsun=6.96e10
	Lsun=3.86e33

	L(1)=0.7523
	L(2)=2.12
	L(3)=7.25
	L(4)=129
	L(5)=3127
	L(6)=11050

	R(1)=0.92
	R(2)=1.3
	R(3)=1.5
	R(4)=2.2
	R(5)=3.4
	R(6)=3.9

	do i=1,6
	   Te(i)=(L(i)*Lsun)/(4.*pi*sigma*(R(i)*Rsun)**2)
	   Te(i)=Te(i)**0.25
           Te(i)=log10(Te(i))
	   L(i)=log10(L(i))
	enddo



C 	Call plotting for polytrope ZAMS

        xmin=3.7
        xmax=4.5
        ymin=-0.2
        ymax=4.2

         CALL PGBEG(0,'?',1,1)
         call pgpap(10.0,0.8)
         call pgenv(xmax,xmin,ymin,ymax,0,0)
         call pglabel('Log(Te)', 'L/Lsun',
     &                ' ZAMS')

         call pgsci(2)
         call pgline(6,Te,L)
C         call pgpoint(6,Te,L,254)



	rL(1)=0.75
	rL(2)=4.8
	rL(3)=20
	rL(4)=275
	rL(5)=3100
	rL(6)=6500

	do i=1,6
	   rTe(i)=(rL(i)*Lsun)/(4.*pi*sigma*(R(i)*Rsun)**2)
	   rTe(i)=rTe(i)**0.25
           rTe(i)=log10(rTe(i))
	   rL(i)=log10(rL(i))
	enddo



        write(6,*) rTE
        write(6,*) rL

C	Call plotting for real ZAMS

         call pgsci(3)
         call pgline(6,rTe,rL)


         call pgsci(4)
         call pgsls(2)
         x(1)=Te(1)
         x(2)=rTe(1)
         y(1)=L(1)
         y(2)=rL(1)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,551)
         call pgmtxt('T',1.0,0.5,1.0,LINE1)
 551     format('M=1')


         call pgsci(5)
         call pgsls(2)
         x(1)=Te(2)
         x(2)=rTe(2)
         y(1)=L(2)
         y(2)=rL(2)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,552)
         call pgmtxt('T',1.0,0.6,1.0,LINE1)
 552     format('M=1.4')


         call pgsci(6)
         call pgsls(2)
         x(1)=Te(3)
         x(2)=rTe(3)
         y(1)=L(3)
         y(2)=rL(3)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,553)
         call pgmtxt('T',1.0,0.7,1.0,LINE1)
 553     format('M=2')


         call pgsci(7)
         call pgsls(2)
         x(1)=Te(4)
         x(2)=rTe(4)
         y(1)=L(4)
         y(2)=rL(4)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,554)
         call pgmtxt('T',1.0,0.8,1.0,LINE1)
 554     format('M=4')



         call pgsci(8)
         call pgsls(2)
         x(1)=Te(5)
         x(2)=rTe(5)
         y(1)=L(5)
         y(2)=rL(5)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,555)
         call pgmtxt('T',1.0,0.9,1.0,LINE1)
 555     format('M=8')


         call pgsci(10)
         call pgsls(2)
         x(1)=Te(6)
         x(2)=rTe(6)
         y(1)=L(6)
         y(2)=rL(6)
         call pgline(2,x,y)
         call pgpoint(2,x,y,254)
         write(LINE1,556)
         call pgmtxt('T',1.0,1.0,1.0,LINE1)
 556     format('M=10')


         write(LINE1,530)
         call pgsci(2)
         call pgmtxt('T',1.0,0.0,0.0,LINE1)
 530     format('Polytropes')

         write(LINE1,540)
         call pgsci(3)
         call pgmtxt('T',1.0,0.15,0.0,LINE1)
 540     format('Detailed Models')



	call pgend

         stop
         end
