      implicit none
      real*8 x,y,z,h,hmax,hmin
      real*8 a,yinitial,f,g,n,ynew
      real*8 dh(6),xarg,yarg,zarg
      real*8 k1,k2,k3,k4,k5,k6
      real*8 l1,l2,l3,l4,l5,l6
      real*8 tol,Ry,Rz,deltay,deltaz,R
      real*8 x2,x3,x4,x5,x6,delta,amin,temp
      character*20 TITLE
      real*4 xiplot(1000),thplot(1000),thplotn(1000)
      real*4 xmin,xmax,ymin,ymax
      real*4 xline(2),yline(2)
      common n
      integer icount,iout,index,i,npts,ii,jj

      dh(1)=0.
      dh(2)=1./4.
      dh(3)=3./8.
      dh(4)=12./13.
      dh(5)=1.
      dh(6)=1./2.
      index=0

C	This Program solves the Lane-Emden Equation'
C	It uses the Runge-Kutta-Fehlberg method with a 
C	tolerance of 1.e-8 (or user specififed!)

      write(6,*) ' Enter polytropic index n'
      read(5,*) n

      write(6,*) '      '
      write(6,*) ' Output every iout steps: Enter iout (99 for none)'
      read(5,*) iout
      tol=1.d-8

C     Place restrictions on hmax and hmin
C     These are also used to find the edge accurately
      write(6,*) '      '
      write(6,*) ' Enter maximum step-length h (larger for larger n)'
      read(5,*) hmax

      write(6,*) ' Enter tolerance = maximum error'
      read(5,*) tol
      hmin=tol
C      if(n.gt.4.4) then
C	hmax=0.5
C      else if(n.gt.4.8) then
C	hmax=1.0
C      endif

C     Start at x=tolerance
      x=tol

C     Use series solution to begin near origin
      x2=x*x
      x3=x2*x
      x4=x2*x2
      x5=x4*x
      x6=x4*x2
      y=1-x2/6. + n*x4/120.-n*(8*n-5)*x6/(42*360)
      z=-x/3. +n*x3/30.-n*(8*n-5)*x5/(7*360)

C     Start with h=hmin=tol
      h=x

      if(iout.ne.99) print 11
 11   format('          x            y         z        h')
      if(iout.ne.99) print 10,x,y,z,h

      icount=0

 100  continue
C     We should never use the next line !
      if(y.le.0) go to 200

      k1=h*f(x,y,z)
      l1=h*g(x,y,z)

      xarg=x+dh(2)*h
      yarg=y+k1*0.25
      if(yarg.le.0) go to 200
C     Then non-integer n will cause problems. 
C     Reduce h and restart this step.
      zarg=z+l1*0.25
      k2=h*f(xarg,yarg,zarg)
      l2=h*g(xarg,yarg,zarg)

      xarg=x+dh(3)*h
      yarg=y+3.*(k1+3.*k2)/32.
      if(yarg.le.0) go to 200
      zarg=z+3.*(l1+3.*l2)/32.
      k3=h*f(xarg,yarg,zarg)
      l3=h*g(xarg,yarg,zarg)

      xarg=x+dh(4)*h
      yarg=y+(1932.*k1-7200.*k2+7296.*k3)/2197.
      if(yarg.le.0) go to 200
      zarg=z+(1932.*l1-7200.*l2+7296.*l3)/2197.
      k4=h*f(xarg,yarg,zarg)
      l4=h*g(xarg,yarg,zarg)

      xarg=x+dh(5)*h
      yarg=y+439.*k1/216.-8.*k2+3680.*k3/513.-845.*k4/4104.
      if(yarg.le.0) go to 200
      zarg=z+439.*l1/216.-8.*l2+3680.*l3/513.-845.*l4/4104.
      k5=h*f(xarg,yarg,zarg)
      l5=h*g(xarg,yarg,zarg)

      xarg=x+0.5*h
      yarg=y-8.*k1/27.+2.*k2-3544.*k3/2565.+ 
     &    1859.*k4/4104.-11.*k5/40.
	if(yarg.le.0) go to 200
      zarg=z-8.*l1/27.+2.*l2-3544.*l3/2565.+ 
     &    1859.*l4/4104.-11.*l5/40.
      k6=h*f(xarg,yarg,zarg)
      l6=h*g(xarg,yarg,zarg)

C     Error controlling R values
      Ry=abs(k1/360.-128.*k3/4275.-2197.*k4/75240.+
     &     k5/50.+2.*k6/55.)/h
      Rz=abs(l1/360.-128.*l3/4275.-2197.*l4/75240.+
     &     l5/50.+2.*l6/55.)/h
      R=min(Ry,Rz)
      if(R.ne.0) delta=0.84*(tol/R)**0.25

C     if R < tol then this step is accepted.....
      if(R.le.tol) then
         ynew=y+25.*k1/216.+1408.*k3/2565.+2197.*k4/4104.-0.2*k5
C........provided y is still positive.......
C        if this y < 0 then reduce h and re-compute this step...
         if(ynew.lt.0) then
            if(h.gt.tol) then
               h=0.5*h
               go to 100
            else
C..............unless h < tol = hmin. In this case
C              we have found the surface...so print and stop.
300	       print 30,x,-x/(3*z),-x*x*z
               stop
            endif
         endif

C        Step accepted, y > 0

C        Update x and z also
         y=ynew
         x=x+h
         z=z+25.*l1/216.+1408.*l3/2565.+2197.*l4/4104.
     &        -0.2*l5



C        Set up stuff to plot
         index=index+1
         xiplot(index)=x
         thplot(index)=y
         thplotn(index)=y**n

C        If required, print out the x,y,z and h for this step
	 icount=icount+1
         if(iout.ne.99) then
            if(mod(icount,iout).eq.0) print 10,x,y,z,h
         endif
      else
C        Here R > tol, so we must reduce h.
C        This step is NOT accepted.
	 if(iout.ne.99) print 20,Ry,Rz,tol,h
      endif

C     Now adjust h
      if(delta.le.0.5) then
         h=0.5*h
      else if (delta.gt.2) then
         h=2.*h
      else
         h=delta*h
      endif

      if(h.gt.hmax) h = hmax
      if(y.lt.0) stop
      if(h.lt.hmin) h=hmin
      go to 100

200   continue
C     Must reduce h as y went negative on this step
      h=0.5*h
C     But if this makes h < tol, then we have finished !
      if(h.lt.tol) then
	     print 30,x,-x/(3*z),-x*x*z
             go to 500
      endif
C     Reduced h....go back to calculate the next step.
      go to 100

C     FORMAT statements
10    format(2x,1pe14.6,2x,0pf8.6,2x,f8.5,2x,f8.5)
20    format('   *Ry=',e11.4,' Rz=',e11.4,' tol=',e10.3,
     &       '   h=',f6.4)
30    format(//,' Solution: radius            = ',f10.5,/,
     &	        '           rho(c)/rho(bar)   = ',f10.5,/,
     &          '           -x^2 d(theta)/dx  = ',f10.5,//)


 500  continue
C     Plot stuff
      npts=index

      xmax=-100
      ymax=-100
      xmin=100
      ymin=100

      do i=1,npts
         xmax=max(xmax,xiplot(i))
         xmin=min(xmin,xiplot(i))
         ymax=max(ymax,thplot(i))
         ymin=min(ymin,thplot(i))
      enddo


C     Set up max and min allowing for negative numbers :-/
      if(xmin.gt.0) xmin = 0.98*xmin
      if(ymin.gt.0) ymin = 0.98*ymin

      if(xmin.lt.0) xmin = 1.02*xmin
      if(ymin.lt.0) ymin = 1.02*ymin

      if(xmax.gt.0) xmax = 1.02*xmax
      if(ymax.gt.0) ymax = 1.02*ymax

      if(xmax.lt.0) xmax = 0.98*xmax
      if(ymax.lt.0) ymax = 0.98*ymax


      CALL PGBEG(0,'?',1,1)
      call pgpap(10.0,0.8)
      call pgenv(xmin,xmax,ymin,ymax,0,0)

      write(TITLE,501) n
 501  format('Polytrope with n=',f3.1)

      call pglabel('Xi', 'Theta',TITLE)

      xline(1)=xmin
      xline(2)=xmax
      yline(1)=0.5
      yline(2)=0.5

      call pgsci(2)
      call pgline(npts,xiplot,thplot)
      call pgsci(3)
      call pgline(2,xline,yline)
      
      ii=0
 600  continue
      ii=ii+1
      if(thplot(ii).gt.0.5) go to 600
      jj=ii
      temp=xiplot(jj)
      
C      write(6,*) jj,thplot(jj)

      if(abs(thplot(jj)-0.5).ge.0.001) then
         temp=xiplot(jj)-xiplot(jj-1)
         temp=temp/(thplot(jj)-thplot(jj-1))
         temp=xiplot(jj) + (0.5-thplot(jj))*temp
      endif

      xline(1)=temp
      xline(2)=temp
      yline(1)=ymin
      yline(2)=ymax

      call pgsci(3)
      call pgline(2,xline,yline)


      call pgsci(7)
      call pgpoint(npts,xiplot,thplot,254)

      call pgend

C     Now plot theta^n

      ymin=100
      ymax=-100

      do i=1,npts
         ymax=max(ymax,thplotn(i))
         ymin=min(ymin,thplotn(i))
      enddo


C     Set up max and min allowing for negative numbers :-/
      if(ymin.gt.0) ymin = 0.98*ymin
      if(ymin.lt.0) ymin = 1.02*ymin
      if(ymax.gt.0) ymax = 1.02*ymax
      if(ymax.lt.0) ymax = 0.98*ymax


      CALL PGBEG(0,'?',1,1)
      call pgpap(10.0,0.8)
      call pgenv(xmin,xmax,ymin,ymax,0,0)
      call pglabel('Xi', 'Theta**n',TITLE)

      xline(1)=xmin
      xline(2)=xmax
      yline(1)=0.5
      yline(2)=0.5

      call pgsci(2)
      call pgline(npts,xiplot,thplotn)
      call pgsci(3)
      call pgline(2,xline,yline)
      
      ii=0
 601  continue
      ii=ii+1
      if(thplotn(ii).gt.0.5) go to 601
      jj=ii
      temp=xiplot(jj)

      if(abs(thplotn(jj)-0.5).ge.0.001) then
         temp=xiplot(jj)-xiplot(jj-1)
         temp=temp/(thplotn(jj)-thplotn(jj-1))
         temp=xiplot(jj) + (0.5-thplotn(jj))*temp
      endif

      xline(1)=temp
      xline(2)=temp
      yline(1)=ymin
      yline(2)=ymax

      call pgsci(3)
      call pgline(2,xline,yline)

      call pgsci(7)
      call pgpoint(npts,xiplot,thplotn,254)


      call pgend



      stop
      end




C     f is z=f(x,y,z)=dy/dz
      real*8 function f(x,y,z)
      real*8 x,y,z
      f=z
      return
      end

C     g is z'=g(x,y,z)=dz/dz
      real*8 function g(x,y,z)
      common n
      real*8 x,y,z,n
      g=-2*z/x -y**n
      return
      end
