      implicit none
      character LINE1*30
      real*4 rorsun(1000),thetan(1000),dthetadxi(1000),L(1000)
      real*4 Lpp(1000),LCNO(1000)
      real*8 theta(1000),conv3,conv4,luminosity,xcno
      real*8 alpha,rhoc,rtot,conv1,conv2,rsun,msun,lsun
      real*8 x,y,z,h,hmax,hmin,rtotorsun,momsun,mass,pi
      real*8 a,yinitial,f,g,n,ynew,Grav,T,T6,Pc,rho(1000)
      real*8 dh(6),xarg,yarg,zarg,t6c,totmass
      real*8 k1,k2,k3,k4,k5,k6
      real*8 l1,l2,l3,l4,l5,l6
      real*8 tol,Ry,Rz,deltay,deltaz,R
      real*8 conv5,t623,t6c23,rt613,rt6c13
      real*8 epsilonpp(1000),epsiloncno(1000)
      real*8 x2,x3,x4,x5,x6,delta,amin,rgas
      real*8 k,mu,Tc,xfrac,yfrac,dm(1000),epsilon(1000)
      real*8 narray(7),denom
      real*4 xmin,xmax,ymin,ymax
      common n
      integer icount,iout,nsteps,i,idecide,j,nused,irtot,iltot
      integer index,toocold

      parameter(pi=3.1415926,rsun=6.96d10,msun=1.989d33)
      parameter(lsun=3.827d33,rgas=8.31e7,Grav=6.67d-8)

      dh(1)=0.
      dh(2)=1./4.
      dh(3)=3./8.
      dh(4)=12./13.
      dh(5)=1.
      dh(6)=1./2.

      narray(1)=0.0
      narray(1)=0.5
      narray(2)=1.0
      narray(3)=1.5
      narray(4)=2.0
      narray(5)=3.0
      narray(6)=4.0

      do index=1,6


      idecide=0
      nsteps=-1
C	This Program solves the Lane-Emden Equation'
C	It uses the Runge-Kutta-Fehlberg method with a 
C	tolerance of 1.e-8

c	write(6,*)' Plotagainst r/Rsun (0) or r/R (1):'
C	read(5,*)irtot
c	write(6,*)' Plot l/lsun (0) or l/L (1):'
C	read(5,*)iltot
        irtot=1
        iltot=1
555   continue

C      write(6,*)' Enter X and Y'
C      read(5,*)xfrac,yfrac
      xfrac=0.7 
      yfrac=0.28
      mu=2./(1+3.*xfrac+0.5*yfrac)
      xcno=0.6*(1.0-xfrac-yfrac)


C      write(6,*)' Enter n (negative to stop)'
C      read(5,*)n
C      if(n.lt.0.0) stop
C      if(n.gt.4.999) stop "Don't be a smart-arse!"

      n=narray(index)

c      write(6,*)' Enter R/Rsun, M/Msun'
c      read(5,*) rtotorsun,momsun
      rtotorsun=1
      momsun=1

      rtot=rtotorsun*rsun
      mass=momsun*msun

      tol=1.d-8

C     Place restrictions on hmax and hmin
C     These are also used to find the edge accurately
      hmin=tol
      hmax=0.1

C     Start at x=tolerance
      x=tol

C     Use series solution to begin near origin
      x2=x*x
      x3=x2*x
      x4=x2*x2
      x5=x4*x
      x6=x4*x2
      y=1-x2/6. + n*x4/120.-n*(8*n-5)*x6/(42*360)
      z=-x/3. +n*x3/30.-n*(8*n-5)*x5/(7*360)

C     Start with h=hmin=tol
      h=x

C     print 11
 11   format('         xi            theta',
     &'     d(theta)/d(xi)      h')
C      print 10,x,y,z,h

      i=1
      rorsun(1)=x
      theta(1)=y
      thetan(1)=y**n
      dthetadxi(1)=z
      icount=0

 100  continue
C     We should never use the next line !
      if(y.le.0) go to 200

      k1=h*f(x,y,z)
      l1=h*g(x,y,z)

      xarg=x+dh(2)*h
      yarg=y+k1*0.25
      if(yarg.le.0) go to 200
C     Then non-integer n will cause problems. 
C     Reduce h and restart this step.
      zarg=z+l1*0.25
      k2=h*f(xarg,yarg,zarg)
      l2=h*g(xarg,yarg,zarg)

      xarg=x+dh(3)*h
      yarg=y+3.*(k1+3.*k2)/32.
      if(yarg.le.0) go to 200
      zarg=z+3.*(l1+3.*l2)/32.
      k3=h*f(xarg,yarg,zarg)
      l3=h*g(xarg,yarg,zarg)

      xarg=x+dh(4)*h
      yarg=y+(1932.*k1-7200.*k2+7296.*k3)/2197.
      if(yarg.le.0) go to 200
      zarg=z+(1932.*l1-7200.*l2+7296.*l3)/2197.
      k4=h*f(xarg,yarg,zarg)
      l4=h*g(xarg,yarg,zarg)

      xarg=x+dh(5)*h
      yarg=y+439.*k1/216.-8.*k2+3680.*k3/513.-845.*k4/4104.
      if(yarg.le.0) go to 200
      zarg=z+439.*l1/216.-8.*l2+3680.*l3/513.-845.*l4/4104.
      k5=h*f(xarg,yarg,zarg)
      l5=h*g(xarg,yarg,zarg)

      xarg=x+0.5*h
      yarg=y-8.*k1/27.+2.*k2-3544.*k3/2565.+ 
     &    1859.*k4/4104.-11.*k5/40.
	if(yarg.le.0) go to 200
      zarg=z-8.*l1/27.+2.*l2-3544.*l3/2565.+ 
     &    1859.*l4/4104.-11.*l5/40.
      k6=h*f(xarg,yarg,zarg)
      l6=h*g(xarg,yarg,zarg)

C     Error controlling R values
      Ry=abs(k1/360.-128.*k3/4275.-2197.*k4/75240.+
     &     k5/50.+2.*k6/55.)/h
      Rz=abs(l1/360.-128.*l3/4275.-2197.*l4/75240.+
     &     l5/50.+2.*l6/55.)/h
      R=min(Ry,Rz)
      if(R.ne.0) delta=0.84*(tol/R)**0.25

C     if R < tol then this step is accepted.....
      if(R.le.tol) then
         ynew=y+25.*k1/216.+1408.*k3/2565.+2197.*k4/4104.-0.2*k5
C........provided y is still positive.......
C        if this y < 0 then reduce h and re-compute this step...
         if(ynew.lt.0) then
            if(nsteps.lt.0) then
		nsteps=icount
C		write(6,40) nsteps
	    endif
            if(h.gt.tol) then
               h=0.5*h
               go to 100
            else
C..............unless h < tol = hmin. In this case
C              we have found the surface...so print and stop.
               go to 300
            endif
         endif

C        Step accepted, y > 0
C        Update x and z also
         y=ynew
         x=x+h
         z=z+25.*l1/216.+1408.*l3/2565.+2197.*l4/4104.
     &        -0.2*l5
	 i=i+1
	 rorsun(i)=x
         theta(i)=y
	 thetan(i)=y**n
	 dthetadxi(i)=z

C        If required, print out the x,y,z and h for this step
	 icount=icount+1
C         if(mod(icount,iout).eq.0) print 10,x,y,z,h
      else
C        Here R > tol, so we must reduce h.
C        This step is NOT accepted.
C	 write(6,20) Ry,Rz,tol,h
      endif

C     Now adjust h
      if(delta.le.0.5) then
         h=0.5*h
      else if (delta.gt.2) then
         h=2.*h
      else
         h=delta*h
      endif

      if(h.gt.hmax) h = hmax
      if(y.lt.0) stop
      if(h.lt.hmin) h=hmin
      go to 100

200   continue
C     Must reduce h as y went negative on this step
      h=0.5*h
C     But if this makes h < tol, then we have finished !
      if(h.lt.tol) then
         go to 300
      endif
C     Reduced h....go back to calculate the next step.
      go to 100



300	       continue
               toocold=1
               write(6,30) n,x,-x/(3*z),-x*x*z
               write(6,50) icount
	       i=i+1
	       nused=i
	       rorsun(i)=x
	       theta(i)=y
               thetan(i)=y**n
               dthetadxi(i)=z
C	Fix scaling here
	       L(1)=0
               Lpp(1)=0.0
               LCNO(1)=0.0
	       alpha=rtot/x
	       conv1=alpha/rsun
	       rhoc=((mass/alpha)/alpha)/(4.*pi*alpha*(-x*x*z))
	       do j=1,nused
		   rorsun(j)=rorsun(j)*alpha
		   rho(j)=thetan(j)*rhoc
	       enddo
	       K=4.*pi*Grav*alpha*alpha
	       denom=((n+1)*rhoc**(1/n-1.))
	       K=K/denom
	       Pc=K*rhoc**(1+1/n)
	       Tc=mu*Pc/(rhoc*Rgas)

C               write(6,*) 'alpha=',alpha
C               write(6,*) ' K,Pc,rhoc=',K,Pc,rhoc

	       conv2=4.*pi*rhoc/3.
	       dm(1)=conv2*(rorsun(1)**3)
	       conv2=2.4d6*xfrac*xfrac
	       conv5=8.6d27*xcno*xfrac
	       t6c=tc*1.d-6
	       rt6c13=1./(t6c**(0.333333))
	       t6c23=(t6c**(-0.6666666667))
	       epsilonpp(1)=conv2*rhoc*t6c23*exp(-33.8*rt6c13)
	       epsiloncno(1)=conv5*rhoc*t6c23*exp(-152.28*rt6c13)
	       epsilon(1)=epsilonpp(1)+epsiloncno(1)

C               write(6,*) rhoc
C               write(6,*) epsilonpp(1),epsiloncno(1)

	       totmass=dm(1)
	       do j=2,nused
		  conv3=rorsun(j)+rorsun(j-1)
		  conv4=rho(j)+rho(j-1)
		  dm(j)=0.5*pi*(conv3*conv3)*(conv4)
		  dm(j)=dm(j)*(rorsun(j)-rorsun(j-1))
		  totmass=totmass+dm(j)
		  T=Tc*theta(j)
		  epsilon(j)=0
		  if(T.gt.10000) then
                    toocold=0
		    T6=t*1.e-6
	            rt613=1./(t6**(0.333333))
	            t623=(t6**(-0.6666666667))
	            epsilonpp(j)=conv2*rho(j)*t623*exp(-33.8*rt613)
	            epsiloncno(j)=(conv5*exp(-152.28*rt613))*rho(j)*t623
	            epsilon(j)=epsilonpp(j)+epsiloncno(j)
		  endif
	          Lpp(j)=Lpp(j-1)+dm(j-1)*epsilonpp(j-1)/lsun
	          LCNO(j)=LCNO(j-1)+dm(j-1)*epsiloncno(j-1)/lsun
	          L(j)=L(j-1)+dm(j-1)*epsilon(j-1)/lsun
	       enddo

C               write(6,*) ' toocold=',toocold
               
               if(toocold.eq.0) then
                 if(L(nused).le.1e5) then
    	            write(6,60) L(nused), Lpp(nused), LCNO(nused)
                 else
                    write(6,61) L(nused), Lpp(nused), LCNO(nused)
                 endif
               else
                  write(6,70) Tc
                  go to 666
               endif
		if(irtot.eq.1) then
			conv1=1./rorsun(nused)
		else
		        conv1=1./rsun
		endif
		if(iltot.eq.1) then
			conv4=1./(L(nused))
		else
			conv4=1
		endif
C	write(6,*)' conv1, conv4=',conv1, conv4
	       do j=1,nused
		   rorsun(j)=rorsun(j)*conv1
	           L(j)=L(j)*conv4
	           Lpp(j)=Lpp(j)*conv4
	           LCNO(j)=LCNO(j)*conv4
	       enddo
	       luminosity=L(nused)

               xmax=-100
               xmin=100
               ymax=-100
               ymin=100
               do i=1,nused
                  xmax=max(xmax,rorsun(i))
                  ymax=max(ymax,L(i))
                  xmin=min(xmin,rorsun(i))
                  ymin=min(ymin,L(i))
               enddo

C                write(6,*),xmin,xmax,ymin,ymax
 666     continue
         if(index.eq.1) then
            CALL PGBEG(0,'?',1,1)
            call pgpap(10.0,0.8)
            call pgenv(xmin,xmax,ymin,ymax,0,0)
            call pglabel('r/R', 'L/Ltot',
     &                ' Polytrope solutions')
         endif

         write(LINE1,510)
         call pgsci(2)
         call pgmtxt('T',-6.0,0.55,0.5,LINE1)
 510     format('n=0.5')

         write(LINE1,520)
         call pgsci(3)
         call pgmtxt('T',-7.0,0.44,0.5,LINE1)
 520     format('n=1.0')

         write(LINE1,530)
         call pgsci(4)
         call pgmtxt('T',-8.0,0.35,0.5,LINE1)
 530     format('n=1.5')

         write(LINE1,540)
         call pgsci(5)
         call pgmtxt('T',-9.0,0.24,0.5,LINE1)
 540     format('n=2.0')

         write(LINE1,550)
         call pgsci(6)
         call pgmtxt('T',-10.,0.15,0.5,LINE1)
 550     format('n=3.0')

         write(LINE1,560)
         call pgsci(7)
         call pgmtxt('T',-11.0,0.05,0.5,LINE1)
 560     format('n=4.0')


         if(toocold.ne.1) then
c            call pgsci(2)
c            call pgline(nused-1,rorsun,Lpp)
c            call pgsci(3)
c            call pgline(nused-1,rorsun,LCNO)
            call pgsci(index+1)
            call pgline(nused-1,rorsun,L)
         endif

         enddo
C     ends n loop
         call pgend
         stop




C     FORMAT statements
10    format(2x,e14.6,5x,f8.6,6x,f8.6,6x,f8.6)
20    format('        Ry=',e13.6,' Rz=',e13.6,' tol=',e13.6,
     &       '   h=',f11.9)
30    format(//,' n=',f3.1,':    radius         = ',f11.6,/,
     &	        '           rho(c)/rho(bar)=    ',1pe12.6,/,
     &          '           -x^2 dthetadx  = ',0pf11.6)
40    format(' (First negative theta after ',i3,' steps.)')
50    format('           Total number of steps = ',i4,//,
     &       '           Scaling:    R = Rsun     M = Msun')
60    format('           Total Luminosity      = ',f9.4,/,
     &       '              pp Luminosity      = ',f9.4,/,
     &       '             CNO Luminosity      = ',f9.4,/)
 61   format('           Total Luminosity      = ',1pe11.3,/,
     &       '              pp Luminosity      = ',e11.3,/,
     &       '             CNO Luminosity      = ',e11.3,/)
70    format(' ***Not hot enough for burning!*** Tmax=',1pe9.2)
      end



C     f is z=f(x,y,z)=dy/dz
      real*8 function f(x,y,z)
      real*8 x,y,z
      f=z
      return
      end

C     g is z'=g(x,y,z)=dz/dz
      real*8 function g(x,y,z)
      common n
      real*8 x,y,z,n
      g=-2*z/x -y**n
      return
      end
